"use strict";

var _excluded = ["stopNow", "returnNow"];

function _await(value, then, direct) {
  if (direct) {
    return then ? then(value) : value;
  }

  if (!value || !value.then) {
    value = Promise.resolve(value);
  }

  return then ? value.then(then) : value;
}

function _catch(body, recover) {
  try {
    var result = body();
  } catch (e) {
    return recover(e);
  }

  if (result && result.then) {
    return result.then(void 0, recover);
  }

  return result;
}

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

Object.defineProperty(exports, "__esModule", {
  value: true
});

var shared_1 = require("@taro-hooks/shared");

var Fetch = /*#__PURE__*/function () {
  function Fetch(serviceRef, options, subscribe, initState) {
    if (initState === void 0) {
      initState = {};
    }

    this.serviceRef = void 0;
    this.options = void 0;
    this.subscribe = void 0;
    this.initState = void 0;
    this.pluginImpls = void 0;
    this.count = 0;
    this.state = {
      loading: false,
      params: undefined,
      data: undefined,
      error: undefined
    };
    this.serviceRef = serviceRef;
    this.options = options;
    this.subscribe = subscribe;
    this.initState = initState;
    this.state = _extends({}, this.state, {
      loading: !options.manual
    }, initState);
  }

  var _proto = Fetch.prototype;

  _proto.setState = function setState(s) {
    if (s === void 0) {
      s = {};
    }

    this.state = _extends({}, this.state, s);
    this.subscribe();
  };

  _proto.runPluginHandler = function runPluginHandler(event) {
    for (var _len = arguments.length, rest = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      rest[_key - 1] = arguments[_key];
    }

    // @ts-ignore
    var r = this.pluginImpls.map(function (i) {
      var _i$event;

      return (_i$event = i[event]) == null ? void 0 : _i$event.call.apply(_i$event, [i].concat(rest));
    }).filter(Boolean);
    return Object.assign.apply(Object, [{}].concat(r));
  };

  _proto.runAsync = function runAsync() {
    for (var _len2 = arguments.length, params = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      params[_key2] = arguments[_key2];
    }

    try {
      var _this2 = this;

      _this2.count += 1;
      var currentCount = _this2.count;

      var _this2$runPluginHandl = _this2.runPluginHandler('onBefore', params),
          _this2$runPluginHandl2 = _this2$runPluginHandl.stopNow,
          stopNow = _this2$runPluginHandl2 === void 0 ? false : _this2$runPluginHandl2,
          _this2$runPluginHandl3 = _this2$runPluginHandl.returnNow,
          returnNow = _this2$runPluginHandl3 === void 0 ? false : _this2$runPluginHandl3,
          state = _objectWithoutPropertiesLoose(_this2$runPluginHandl, _excluded); // stop request


      if (stopNow) {
        return _await(new Promise(function () {}));
      }

      _this2.setState(_extends({
        loading: true,
        params: params
      }, state)); // return now


      if (returnNow) {
        return Promise.resolve(state.data);
      }

      _this2.options.onBefore == null ? void 0 : _this2.options.onBefore(params);
      return _await(_catch(function () {
        // replace service
        var _this2$runPluginHandl4 = _this2.runPluginHandler('onRequest', _this2.serviceRef.current, params),
            servicePromise = _this2$runPluginHandl4.servicePromise;

        if (!servicePromise) {
          var _this2$serviceRef;

          servicePromise = (_this2$serviceRef = _this2.serviceRef).current.apply(_this2$serviceRef, params);
        }

        return _await(servicePromise, function (res) {
          if (currentCount !== _this2.count) {
            // prevent run.then when request is canceled
            return new Promise(function () {});
          } // const formattedResult = this.options.formatResultRef.current ? this.options.formatResultRef.current(res) : res;


          _this2.setState({
            data: res,
            error: undefined,
            loading: false
          });

          _this2.options.onSuccess == null ? void 0 : _this2.options.onSuccess(res, params);

          _this2.runPluginHandler('onSuccess', res, params);

          _this2.options.onFinally == null ? void 0 : _this2.options.onFinally(params, res, undefined);

          if (currentCount === _this2.count) {
            _this2.runPluginHandler('onFinally', params, res, undefined);
          }

          return res;
        });
      }, function (error) {
        if (currentCount !== _this2.count) {
          // prevent run.then when request is canceled
          return new Promise(function () {});
        }

        _this2.setState({
          error: error,
          loading: false
        });

        _this2.options.onError == null ? void 0 : _this2.options.onError(error, params);

        _this2.runPluginHandler('onError', error, params);

        _this2.options.onFinally == null ? void 0 : _this2.options.onFinally(params, undefined, error);

        if (currentCount === _this2.count) {
          _this2.runPluginHandler('onFinally', params, undefined, error);
        }

        throw error;
      }));
    } catch (e) {
      return Promise.reject(e);
    }
  };

  _proto.run = function run() {
    var _this3 = this;

    this.runAsync.apply(this, arguments)["catch"](function (error) {
      if (!_this3.options.onError) {
        console.error(error);
      }
    });
  };

  _proto.cancel = function cancel() {
    this.count += 1;
    this.setState({
      loading: false
    });
    this.runPluginHandler('onCancel');
  };

  _proto.refresh = function refresh() {
    // @ts-ignore
    this.run.apply(this, this.state.params || []);
  };

  _proto.refreshAsync = function refreshAsync() {
    // @ts-ignore
    return this.runAsync.apply(this, this.state.params || []);
  };

  _proto.mutate = function mutate(data) {
    var targetData;

    if ((0, shared_1.isFunction)(data)) {
      // @ts-ignore
      targetData = data(this.state.data);
    } else {
      targetData = data;
    }

    this.runPluginHandler('onMutate', targetData);
    this.setState({
      data: targetData
    });
  };

  return Fetch;
}();

exports["default"] = Fetch;